'use strict'

const apemanerror = require('apemanerror')
const ApErrorCodes = apemanerror.ApErrorCodes

const trigger = 'apeman-app-verify'

module.exports = Object.assign(exports, {
  signinRequiredError (type, condition) {
    let code = ApErrorCodes.SIGN_IN_REQUIRED_ERROR
    return Object.assign(
      apemanerror.newError(code, null, {
        trigger,
        context: { type, condition }
      }),
      { status: '401' }
    )
  },

  notFoundError (type, condition) {
    let code = ApErrorCodes.RESOURCE_NOT_FOUND_ERROR
    return Object.assign(
      apemanerror.newError(code, null, {
        trigger,
        context: { type, condition }
      }),
      { status: '404' }
    )
  },

  tokenInvalidError () {
    let code = ApErrorCodes.TOKEN_WRONG_ERROR
    return Object.assign(
      apemanerror.newError(code, null, {
        trigger,
        context: {}
      }),
      { status: '401' }
    )
  },

  tokenExpiredError () {
    let code = ApErrorCodes.TOKEN_EXPIRED_ERROR
    return Object.assign(
      apemanerror.newError(code, null, {
        trigger,
        context: {}
      }),
      { status: '401' }
    )
  },

  somethingWrongError () {
    let code = ApErrorCodes.SOMETHING_WRONG_ERROR
    return Object.assign(
      apemanerror.newError(code, null, {
        trigger,
        context: {}
      }),
      { status: '500' }
    )
  }
})
